﻿using ISendTools4;
using System;
using System.Configuration;
using System.IO;
using System.Reflection;

namespace IOCDemo4
{
    public abstract class SendToolFactory
    {
        public static ISendable GetInstance()
        {
            string assemblyName = GetAssembly();
            string objectTypeName = GetObjectType();

            try
            {
                Assembly assembly = Assembly.LoadFile(assemblyName);
                object obj = assembly.CreateInstance(objectTypeName);
                return obj as ISendable;
            }
            catch (Exception e)
            {
                Console.WriteLine("1：" + e.Message);
                return null;
            }
        }

        static string GetAssembly()
        {
            return Path.Combine(AppDomain.CurrentDomain.BaseDirectory, ConfigurationManager.AppSettings["AssemblyString"]);
        }

        static string GetObjectType()
        {
            return ConfigurationManager.AppSettings["TypeString"];
        }
    }
}
