﻿using Autofac;
using Autofac.Configuration;
using IMessageService5;
using ISendTools5;
using MessageService5;
using Microsoft.Extensions.Configuration;
using SendTools5;
using System;

namespace IOCDemo5
{
    class Program
    {
        static void Main(string[] args)
        {
            string message = "新年快乐！ 过节费5000.";

            ////直接指定实例类型
            ContainerBuilder builder = new ContainerBuilder();
            builder.RegisterType<GreetMessageService>().As<IGreetMessageService>();
            builder.RegisterType<SMSSender>().As<ISendable>();
            using (var container = builder.Build())
            {
                var manager = container.Resolve<IGreetMessageService>();
                manager.Greet(message);
            }

            Console.Write(Environment.NewLine);

            ConfigurationBuilder config = new ConfigurationBuilder();
            config.AddJsonFile("autofac.json");

            ConfigurationModule module = new ConfigurationModule(config.Build());
            ContainerBuilder builder2 = new ContainerBuilder();
            builder2.RegisterModule(module);

            using (var container = builder2.Build())
            {
                var manager = container.Resolve<IGreetMessageService>();
                manager.Greet(message);
            }
            Console.ReadKey();
        }
    }
}
